#
# spec file for package wuftpd (Version 2.6.0)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  
# usedforbuild    aaa_base aaa_dir base bash bindutil bison bzip compress cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim autoconf automake binutils cracklib gcc gdbm gettext libtool libz pam perl rpm

Name:         wuftpd
%define OLDWUFTPD   wu-ftpd-2.4.2-beta-18
Copyright:    1999 WU-FTPD Development Group.
Group:        Networking/Daemons
Provides:     wu-ftpd 
Requires:     ftpdir
Conflicts:    proftpd
Autoreqprov:  on
Version:      2.6.0
Release:      403
Summary:      Wu-FTP server with virtual host support
Source:       wu-ftpd-2.6.0.tar.gz
Source1:      wu-ftpd.pamd
Source2:      wu-ftpd-faq.txt
Source3:      telnet.testing.HOWTO
Source4:      wu-ftpd-2.4.2-beta-18.tar.gz
Patch0:       wu-ftpd-2.4.2-beta-18.dif
Patch1:       wu-ftpd-conf.dif
Patch2:       wu-ftpd-2.6.0-tom.dif
Patch3:       wu-ftpd-2.6.0.dif
Patch4:       wu-ftpd-mkstemp.dif
Patch5:       wu-ftpd-2.6.0-add.dif
Patch6:       wu-ftpd-fmt_2.6.0_and_1.dif
Patch7:       wu-ftpd-glob-patch-for-both.dif
Patch8:       wu-ftpd-2.6.0-rootd.dif
Patch9:       wu-ftpd-connect-dos.patch
Patch10:      wu-ftpd-2.4.2-beta-18.bwlimit.dif

%description
wu-ftpd is a replacement ftp server for Un*x systems.  Besides
supporting the ftp protocol defined in RFC 959, it adds the following
features:
o  logging of transfers
o  logging of commands
o  on the fly compression and archiving
o  classification of users on type and location
o  per class limits
o  per directory upload permissions
o  restricted guest accounts
o  system wide and per directory messages.
o  directory alias
o  cdpath
o  file name filter
o  virtual host support (similar to the apache httpd server)

Authors:
--------
    Anonymous (Internet, Washington University in Saint Louis)

SuSE series: n

%prep
%setup -n wu-ftpd-2.6.0
%setup -n wu-ftpd-2.6.0 -T -D -a 4
cd %{OLDWUFTPD}
%patch0
%patch10
cd ..
%patch1
%patch2
%patch3
%patch4
%patch5
%patch6
%patch7
%patch8
%patch9

%build
export CFLAGS="-O2 -pipe -fno-strength-reduce"
./configure --prefix=$RPM_BUILD_ROOT/usr \
	--sysconfdir=$RPM_BUILD_ROOT/etc \
	--localstatedir=$RPM_BUILD_ROOT/var \
	--disable-dnsretry --disable-verbose \
	--enable-badclients --enable-quota \
	--enable-pam --disable-pasvip --mandir=%{_mandir}
make
strip --strip-all bin/ftpd src/ftpd
cp $RPM_SOURCE_DIR/wu-ftpd-faq.txt      doc/
cp $RPM_SOURCE_DIR/telnet.testing.HOWTO doc/HOWTO/
cd %{OLDWUFTPD}
./build lnx
strip --strip-all bin/ftpd src/ftpd
cd ..

%install
export RPM_BUILD_ROOT
export RPM_SOURCE_DIR
install -d -m 755 $RPM_BUILD_ROOT/etc/pam.d
install -m 644 $RPM_SOURCE_DIR/wu-ftpd.pamd  $RPM_BUILD_ROOT/etc/pam.d/wu-ftpd
install -m 644 -oroot -groot ftpaccess.default  $RPM_BUILD_ROOT/etc/ftpaccess
install -m 644 -oroot -groot doc/msg.dead       $RPM_BUILD_ROOT/etc/ftpmsg.dead
install -m 644 -oroot -groot doc/ftpconversions $RPM_BUILD_ROOT/etc/
install -m 755 -oroot -groot util/xferstats  $RPM_BUILD_ROOT/usr/sbin/xferstats_wuftpd
make install
%define USR   $RPM_BUILD_ROOT/usr
%define USRMAN $RPM_BUILD_ROOT/%{_mandir}
mv %{USR}/bin/ftpwho                %{USR}/bin/ftpwho-2.6
mv %{USR}/bin/ftpcount              %{USR}/bin/ftpcount-2.6
mv %{USR}/sbin/ftpshut              %{USR}/sbin/ftpshut-2.6
mv %{USR}/sbin/wu.ftpd              %{USR}/sbin/wu.ftpd-2.6
mv %{USR}/sbin/ckconfig             %{USR}/sbin/ckconfig-2.6
mv %{USR}/sbin/ftprestart           %{USR}/sbin/ftprestart-2.6
mv %{USRMAN}/man1/ftpwho.1         %{USRMAN}/man1/ftpwho-2.6.1
mv %{USRMAN}/man1/ftpcount.1       %{USRMAN}/man1/ftpcount-2.6.1
mv %{USRMAN}/man5/xferlog.5        %{USRMAN}/man5/xferlog-2.6.5
mv %{USRMAN}/man5/ftphosts.5       %{USRMAN}/man5/ftphosts-2.6.5
mv %{USRMAN}/man5/ftpaccess.5      %{USRMAN}/man5/ftpaccess-2.6.5
mv %{USRMAN}/man5/ftpconversions.5 %{USRMAN}/man5/ftpconversions-2.6.5
mv %{USRMAN}/man8/wu.ftpd.8        %{USRMAN}/man8/wu.ftpd-2.6.8
mv %{USRMAN}/man8/ftpshut.8        %{USRMAN}/man8/ftpshut-2.6.8
mv %{USRMAN}/man8/ftprestart.8     %{USRMAN}/man8/ftprestart-2.6.8
mkdir wuftpd-2.6 && {
cp -r CHANGES CONTRIBUTORS COPYRIGHT ERRATA LICENSE README     wuftpd-2.6
cp -r doc/HOWTO doc/TODO doc/wu-ftpd-faq.txt                   wuftpd-2.6
cp -r doc/examples doc/msg.dead doc/misc/opie doc/welcome.msg  wuftpd-2.6
}
cd %{OLDWUFTPD}
install -s bin/ftpwho               %{USR}/bin/ftpwho
install -s bin/ftpcount             %{USR}/bin/ftpcount
install -s bin/ftpshut              %{USR}/sbin/ftpshut
install -s bin/ftpd                 %{USR}/sbin/wu.ftpd
install -s bin/ckconfig             %{USR}/sbin/ckconfig
#install    util/xferstats          %{USR}/sbin/xferstats_wuftpd
install doc/ftpwho.1                %{USRMAN}/man1/ftpwho.1
install doc/ftpcount.1              %{USRMAN}/man1/ftpcount.1
install doc/xferlog.5               %{USRMAN}/man5/xferlog.5
install doc/ftphosts.5              %{USRMAN}/man5/ftphosts.5
install doc/ftpaccess.5             %{USRMAN}/man5/ftpaccess.5
install doc/ftpconversions.5        %{USRMAN}/man5/ftpconversions.5
install doc/ftpd.8                  %{USRMAN}/man8/wu.ftpd.8
install doc/ftpshut.8               %{USRMAN}/man8/ftpshut.8
mkdir ../wuftpd-2.4 && {
cp ANNOUNCE-18 CLOSED-TICKETS-18 FIXES-2.4* README NOTES        ../wuftpd-2.4
cp -r POSSIBLE-BUGS VIRTUAL.FTP.SUPPORT doc/TODO doc/examples   ../wuftpd-2.4
}
cd ..
#export RPM_BUILD_ROOT ; test -x /usr/sbin/Check -a $UID = 0 && /usr/sbin/Check

%post
mkdir -p var/adm/notify/messages
cat << EOF > var/adm/notify/messages/wuftpd-notify
WuFTPD Changes
--------------
This WuFTPD package includes two versions:
   a security fixed 2.4.2-beta-18 and the actual 2.6.0
Default is the 2.4.2-beta-18, the 2.6.0 version is installed with
the "-2.6" suffix (also the man pages), so if you want to use it,
you have to change the entry:
ftp    stream  tcp     nowait  root    /usr/sbin/tcpd  wu.ftpd -a
in /etc/inetd.conf to:
ftp    stream  tcp     nowait  root    /usr/sbin/tcpd  wu.ftpd-2.6 -a
and execute "killall -HUP inetd" or restart the inetd.
Further, the default configuration file (/etc/ftpaccess) does not
support anonymous ftp. You could replace it with the sample anonymous
config file from /usr/share/doc/packages/wuftpd/ftpaccess.anonymous
and adopt it to your needs.
*****************************************************************************
WuFTPD nderungen
-----------------
Dieses WuFTPD Paket beinhaltet zwei versionen:
   eine 2.4.2-beta-18 mit security fixes und die aktuelle 2.0.6
Als Standard wird die 2.4.2-beta-18 installiert, die 2.6.0 Version
ist mit einem Suffix "-2.6" versiehen (auch die Manual-Seiten).
Um die neuere Version zu benutzen, ndern Sie bitte den Eintrag
ftp    stream  tcp     nowait  root    /usr/sbin/tcpd  wu.ftpd -a
in /etc/inetd.conf zu:
ftp    stream  tcp     nowait  root    /usr/sbin/tcpd  wu.ftpd-2.6 -a
und fhren "killall -HUP inetd" aus oder starten Sie inetd neu.
Weiterhin beinhaltet die Standardkonfiguration (/etc/ftpaccess)
kein anonymous ftp. Sie knnen sie mit der Beispielkonfiguration
aus /usr/share/doc/packages/wuftpd/ftpaccess.anonymous ersetzen
and entsprechend Ihren Bedrfnissen anpassen.
EOF

%files
%doc ftpaccess.anonymous wuftpd-2.6 wuftpd-2.4/*
%config(noreplace) /etc/ftpmsg.dead
%config(noreplace) /etc/ftpaccess
%config(noreplace) /etc/ftpconversions
%config(noreplace) /etc/pam.d/wu-ftpd
/usr/bin/ftpwho*
/usr/bin/ftpcount*
/usr/sbin/ftpshut*
/usr/sbin/wu.ftpd*
/usr/sbin/ckconfig*
/usr/sbin/ftprestart*
/usr/sbin/xferstats_wuftpd*
%doc %{_mandir}/man1/ftpwho*
%doc %{_mandir}/man1/ftpcount*
%doc %{_mandir}/man5/xferlog*
%doc %{_mandir}/man5/ftphosts*
%doc %{_mandir}/man5/ftpaccess*
%doc %{_mandir}/man5/ftpconversions*
%doc %{_mandir}/man8/wu.ftpd*
%doc %{_mandir}/man8/ftpshut*
%doc %{_mandir}/man8/ftprestart*

%changelog -n wuftpd
* Mon Jul 21 2003 - mt@suse.de
- Bugzilla #28107 -- added fix for one-byte buffer overflow
  in src/realpath.c, function fb_realpath.
  new patch file: wu-ftpd-2.6.0-rootd.dif
- Bugzilla #28107 -- applied connect-dos.patch patch provided on
  ftp://ftp.wu-ftpd.org/pub/wu-ftpd/patches/apply_to_2.6.2/
  Fixes a possible denial of service attack on systems that allow
  only one non-connected socket bound to the same local address.
  new patch file: wu-ftpd-connect-dos.patch
* Wed Nov 28 2001 - mt@suse.de
- added ftpglob security bugfix
- added fix for further fmt bugs
- added bandwith limit option patch for wuftpd-2.4
* Fri Nov 16 2001 - mt@suse.de
- added ps spaces truncation in ftpcount.c for v2.4
- applied security related patches by thomas@suse.de for v2.6.0
* Tue Aug 14 2001 - ro@suse.de
- Don't use absolute paths to PAM modules in PAM config files
* Thu May 03 2001 - mt@suse.de
- changed/fixed ps args for ftpwho
- removed include of linux/version.h
* Fri Jan 12 2001 - draht@suse.de
- tmp file security problem in privatepw.c fixed.
* Thu Jan 11 2001 - draht@suse.de
- typo in info mail (2.0.6 instead of 2.6.0)
* Fri Dec 08 2000 - mt@suse.de
- added --disable-pasvip in configure of wuftpd-2.6
* Wed Dec 06 2000 - mt@suse.de
- fixed typos in info mail
* Mon Nov 13 2000 - mt@suse.de
- changed /usr/doc/package to /usr/share/doc/packages
* Mon Jun 26 2000 - mt@suse.de
- SITE EXEC lreply security fix
* Mon Mar 06 2000 - mt@suse.de
- fixed previous "ls ." fix - mea culpa
* Fri Mar 03 2000 - uli@suse.de
- moved man pages to %%{_mandir}
* Sun Feb 27 2000 - mt@suse.de
-  fixed overwrite permission problem (open_flags &= ~O_EXCL)
* Wed Feb 16 2000 - mt@suse.de
- fixed "ls ." problem, cleaner docu install for both versions
- added changes and setup notification (mail)
* Tue Nov 16 1999 - mt@suse.de
- fixed restrictive upload permission default
* Wed Nov 03 1999 - mt@suse.de
- added security fixed wu-ftpd-2.4.2-beta-18 as default to the package
* Fri Oct 29 1999 - ro@suse.de
- deleted pam/cracklib from neededforbuild (they are default for >=6.2)
* Fri Oct 29 1999 - mt@suse.de
- fixed PAM typo (wu-ftpd vs. wu-ftp) in dif file
* Thu Oct 28 1999 - mt@suse.de
- removed some wrong set config switches, checked in for updates
* Tue Oct 26 1999 - mt@suse.de
- fixed config.h.in, so --enable-badclients works now
* Tue Oct 26 1999 - mt@suse.de
- Updated to version 2.6
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Tue Jun 08 1999 - kukuk@suse.de
- Add PAM support, static linking isn't longer possible
* Sat Apr 03 1999 - ro@suse.de
- changed "," to " " in ftpaccess to get on-the-fly compression working
* Wed Feb 10 1999 - ro@suse.de
- added security-patch from hans for realpath.c
* Wed Jan 13 1999 - bs@suse.de
- fixed path in /etc/ftpaccess
* Mon Oct 05 1998 - ro@suse.de
- update to beta18
- ftpd.c : include pathnames.h after shadow.h
  dont redeclare strpbrk for glibc
* Tue Dec 16 1997 - florian@suse.de
- updated the SuSE-documentation
* Thu Dec 11 1997 - florian@suse.de
- add security-patches by Olaf Kirch
* Fri Oct 10 1997 - florian@suse.de
- update to version 2.4.2-beta-15
* Mon Jul 07 1997 - florian@suse.de
- update to version 2.4.2-beta-13
* Tue Jun 03 1997 - bs@suse.de
- moved xferstats to wuftpd.xferstats
* Tue May 27 1997 - florian@suse.de
- use /local/ftp/ftp for the anonymous ftp server
- add xferstats perl script to make a summary of transfers
* Sun Feb 02 1997 - florian@suse.de
- update to new version beta-12
- add bug-fixes from RedHat
- use default umask of 022 instead of 002
